
// module.exports = function (RED) {
// 	"use strict";

// 	// Also load any other dependencies you have
//     const util = require("util");
//     const fs = require('fs-extra');
//     const checkTypes = require('check-types');
//     const verror = require('verror');
// }


module.exports = function (RED) {

    "use strict";

    // const util = require("util");
    // const fs = require('fs-extra');
    // const checkTypes = require('check-types');
    // const verror = require('verror');

    var operators = {
        'eq': function (a, b) { return a == b; },
        'neq': function (a, b) { return a != b; },
        'lt': function (a, b) { return a < b; },
        'lte': function (a, b) { return a <= b; },
        'gt': function (a, b) { return a > b; },
        'gte': function (a, b) { return a >= b; },
        'btwn': function (a, b, c) { return a >= b && a <= c; },
        'cont': function (a, b) { return (a + "").indexOf(b) != -1; },
        'regex': function (a, b, c, d) { return (a + "").match(new RegExp(b, d ? 'i' : '')); },
        'true': function (a) { return a === true; },
        'false': function (a) { return a === false; },
        'null': function (a) { return (typeof a == "undefined" || a === null); },
        'nnull': function (a) { return (typeof a != "undefined" && a !== null); },
        'else': function (a) { return a === true; }
    };

    function processJsonataType(property, type) {
        console.log('prep - p:%s, t:%s', property, type);
        if (type === 'jsonata') {
            try {
                property = RED.util.prepareJSONataExpression(this.property, this);
            } catch (err) {
                // this.error(RED._("switch.errors.invalid-expr", { error: err.message }));
                //hrow new verror(err, RED._("switch.errors.invalid-expr", { error: err.message }));
                throw RED._("loop.errors.invalid-expr", { error: err.message });
            }
        }

        return property;
    }

    function evaluateTypedParameters(node, msg, param, type) {
        console.log('eval - p:%s, t:%s', param, type);
        var prop;
        if (type === 'jsonata') {
            prop = RED.util.evaluateJSONataExpression(param, msg);
        } else {
            prop = RED.util.evaluateNodeProperty(param, type, node, msg);
        }
        return prop;
    }

    function LoopNode(n) {
        console.log(
            `We are loadingg LOOOOOOOOOOOOOOOOOOOOOOOOOOOOOP`
        );


        RED.nodes.createNode(this, n);
        console.log(n);
        this.rules = n.rules || [];
        this.loopType = n.loopType;


        switch (this.loopType) {
            case 'for':
                this.forStart = n.forStart;
                this.forStartType = n.forStartType;
                this.forEnd = n.forEnd;
                this.forEndType = n.forEndType;
                this.forStep = n.forStep;
                this.forStepType = n.forStepType;
                this.forStart = processJsonataType(this.forStart, this.forStartType);
                this.forEnd = processJsonataType(this.forEnd, this.forEndType);
                this.forStep = processJsonataType(this.forStep, this.forStepType);
                break;
            case 'foreach':
                this.foreachCollection = n.foreachCollection;
                this.foreachCollectionType = n.foreachCollectionType;
                this.foreachCollection = processJsonataType(this.foreachCollection, this.foreachCollectionType);
                break;
            case 'while':
                this.property = n.property;
                this.propertyType = n.propertyType || "msg";
                this.property = processJsonataType(this.property, this.propertyType);
                break;
        }






        // console.log('property %s-%j', [this.forStart,this.property)
        this.checkall = n.checkall || "true";
        this.previousValue = null;
        var node = this;
        var valid = true;
        for (var i = 0; i < this.rules.length; i += 1) {
            var rule = this.rules[i];
            if (!rule.vt) {
                if (!isNaN(Number(rule.v))) {
                    rule.vt = 'num';
                } else {
                    rule.vt = 'str';
                }
            }
            if (rule.vt === 'num') {
                if (!isNaN(Number(rule.v))) {
                    rule.v = Number(rule.v);
                }
            } else if (rule.vt === "jsonata") {
                try {
                    rule.v = RED.util.prepareJSONataExpression(rule.v, node);
                } catch (err) {
                    this.error(RED._("loop.errors.invalid-expr", { error: err.message }));
                    valid = false;
                }
            }
            if (typeof rule.v2 !== 'undefined') {
                if (!rule.v2t) {
                    if (!isNaN(Number(rule.v2))) {
                        rule.v2t = 'num';
                    } else {
                        rule.v2t = 'str';
                    }
                }
                if (rule.v2t === 'num') {
                    rule.v2 = Number(rule.v2);
                } else if (rule.v2t === 'jsonata') {
                    try {
                        rule.v2 = RED.util.prepareJSONataExpression(rule.v2, node);
                    } catch (err) {
                        this.error(RED._("loop.errors.invalid-expr", { error: err.message }));
                        valid = false;
                    }
                }
            }
        }

        if (!valid) {
            return;
        }

        this.on('input', function (msg) {
            var response = [];
            try {
                var resMsg = RED.util.cloneMessage(msg)
                var prop, paramForStart, paramForEnd, paramForStep, paramForeachCollection;
                const nodeCtx = node.context();
                var loopId = node.id.replace(/\./g, ':') + ':for';
                var forCtx;
                try {
                    forCtx = node.context().get(loopId);
                } catch (ex) {
                    console.log('Loop not initialized', ex.message);
                }
                switch (node.loopType) {
                    case 'for':
                        console.log(node);
                        console.log(node.id);
                        console.log('For-%s', node.id);
                        console.log('node.context() %j', node.context);
                        console.log(node.context());
                        console.log('node.context().flow');
                        console.log(node.context().flow);
                        console.log('node.context().flow.keys()');
                        console.log(node.context().flow.keys());

                        console.log('Loop Context %j', forCtx);
                        if (forCtx === undefined) {
                            console.log('Assigning loop params %j', [node.forStart, node.forStartType, node.forEnd, node.forEndType, node.forStep, node.forStepType].join(' | '));
                            paramForStart = evaluateTypedParameters(node, msg, node.forStart, node.forStartType);
                            paramForEnd = evaluateTypedParameters(node, msg, node.forEnd, node.forEndType);
                            paramForStep = evaluateTypedParameters(node, msg, node.forStep, node.forStepType);
                            forCtx = {
                                start: parseInt(paramForStart),
                                end: parseInt(paramForEnd),
                                step: parseInt(paramForStep),
                                now: parseInt(paramForStart)
                            }

                        }
                        console.log('Check Start loop %j', forCtx);
                        if (forCtx.step > 0) {
                            if (forCtx.now <= forCtx.end) {
                                resMsg.loop = {
                                    index: forCtx.now
                                }
                                forCtx.now += forCtx.step;
                                console.log('Loop Increment %j', resMsg.loop);
                                response = [resMsg, null];
                            } else {

                                response = [null, resMsg];
                                resMsg.loop = {
                                    index: forCtx.now
                                }
                                console.log('Loop Complete %j', resMsg.loop);
                                forCtx = undefined;
                            }

                        } else {

                        }
                        console.log('Check End loop %j', forCtx);
                        node.context().set(loopId, forCtx);
                        this.send(response);

                        break;
                    case 'foreach':
                        console.log('Loop Context %j', forCtx);
                        if (forCtx === undefined) {
                            console.log('Assigning loop params %j', [node.foreachCollection, node.foreachCollectionType].join(' | '));
                            paramForeachCollection = evaluateTypedParameters(node, msg, node.foreachCollection, node.foreachCollectionType);
                            const collectionType = Object.prototype.toString.call(paramForeachCollection);
                            forCtx = {
                                start: paramForeachCollection,
                                now: paramForeachCollection,
                                type: collectionType === '[object Array]' ? 'array' : collectionType === '[object Object]' ? 'object' : 'unknown',
                                index: 0
                            }
                        }
                        console.log('Check Start loop %j', forCtx);
                        if (forCtx.type === 'array') {
                            if (forCtx.now.length > 0) {
                                var item = forCtx.now.splice(0, 1)[0];
                                resMsg.loop = {
                                    item: item,
                                    index: forCtx.index
                                }
                                forCtx.index++;
                                response = [resMsg, null];
                            } else {
                                resMsg.loop = {
                                    index: forCtx.now
                                }
                                response = [null, resMsg];
                                console.log('Loop Complete %j', resMsg.loop);
                                forCtx = undefined;
                            }

                        } else if (forCtx.type === 'object') {
                            node.error(RED._("loop.errors.not-an-iterable", { error: 'type is ' + forCtx.type }));
                            return;
                        } else {
                            node.error(RED._("loop.errors.not-an-iterable", { error: 'type is ' + forCtx.type }));
                            return;
                        }

                        console.log('Check End loop %j', forCtx);
                        node.context().set(loopId, forCtx);
                        this.send(response);
                        break;
                    case 'while':
                        // this.property = n.property;
                        // this.propertyType = n.propertyType || "msg";
                        prop = evaluateTypedParameters(node, msg, node.property, node.propertyType);
                        break;
                }
                // console.log('Loop Implementation Returning');
                // return;
                // prop = evaluateTypedParameters(node, msg, node.property, node.propertyType)

                // var prop;
                // if (node.propertyType === 'jsonata') {
                //     prop = RED.util.evaluateJSONataExpression(node.property, msg);
                // } else {
                //     prop = RED.util.evaluateNodeProperty(node.property, node.propertyType, node, msg);
                // }
                console.log('property %j-%j', node.property, prop)
                var elseflag = true;
                for (var i = 0; i < node.rules.length; i += 1) {


                    var rule = node.rules[i];
                    var test = prop;
                    console.log('[%s], rule:%j, test:%j', i, rule, test);
                    var v1, v2;
                    if (rule.vt === 'prev') {
                        v1 = node.previousValue;
                    } else if (rule.vt === 'jsonata') {
                        try {
                            v1 = RED.util.evaluateJSONataExpression(rule.v, msg);
                            console.log('Jsonata : %j, %j, %j', rule, test, v1)
                        } catch (err) {
                            node.error(RED._("loop.errors.invalid-expr", { error: err.message }));
                            return;
                        }
                    } else {
                        try {
                            v1 = RED.util.evaluateNodeProperty(rule.v, rule.vt, node, msg);
                        } catch (err) {
                            v1 = undefined;
                        }
                    }
                    v2 = rule.v2;
                    if (rule.v2t === 'prev') {
                        v2 = node.previousValue;
                    } else if (rule.v2t === 'jsonata') {
                        try {

                            v2 = RED.util.evaluateJSONataExpression(rule.v2, msg);
                            console.log('Jsonata : %s, %s, %s', rule.v2, test, v2)
                        } catch (err) {
                            node.error(RED._("loop.errors.invalid-expr", { error: err.message }));
                            return;
                        }
                    } else if (typeof v2 !== 'undefined') {
                        try {
                            v2 = RED.util.evaluateNodeProperty(rule.v2, rule.v2t, node, msg);
                        } catch (err) {
                            v2 = undefined;
                        }
                    }


                    if (rule.t == "else") { test = elseflag; elseflag = true; }
                    console.log('isElse? %s', elseflag);
                    console.log('Eval expre %s, %s, %s, %s, %s', rule.t, test, v1, v2, rule.case);
                    console.log(operators[rule.t](test, v1, v2, rule.case));
                    if (operators[rule.t](test, v1, v2, rule.case)) {
                        console.log('True');
                        onward = [msg, null]
                        elseflag = false;
                        if (node.checkall == "false") { break; }
                    } else {
                        console.log('Null');
                        if(node.checkall=="true"){
                            onward.push(null);
                            break;
                        }
                        // onward.push(null);
                    }
                }
                console.log('onward %j', onward)
                node.previousValue = prop;
                this.send(onward);
            } catch (err) {
                node.warn(err);
            }
        });
    }

    RED.nodes.registerType("orpa-loops", LoopNode);
} 
